package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.X509LDAPCertStoreParameters;
import cn.com.infosec.util.Selector;
import cn.com.infosec.x509.X509CertPairStoreSelector;
import cn.com.infosec.x509.X509CertStoreSelector;
import cn.com.infosec.x509.X509CertificatePair;
import cn.com.infosec.x509.X509StoreParameters;
import cn.com.infosec.x509.X509StoreSpi;
import cn.com.infosec.x509.util.LDAPStoreHelper;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;

public class X509StoreLDAPCerts extends X509StoreSpi {
   private LDAPStoreHelper helper;

   private Collection getCertificatesFromCrossCertificatePairs(X509CertStoreSelector xselector) {
      HashSet var2;
      var2 = new HashSet.<init>();
      X509CertPairStoreSelector var3;
      X509CertPairStoreSelector var10000 = var3 = new X509CertPairStoreSelector;
      var3.<init>();
      var10000.setForwardSelector(xselector);
      var10000.setReverseSelector(new X509CertStoreSelector());
      HashSet var5 = new HashSet(this.helper.getCrossCertificatePairs(var3));
      HashSet var6;
      var6 = new HashSet.<init>();
      HashSet xselector1;
      xselector1 = new HashSet.<init>();
      Iterator var8 = var5.iterator();

      while(var8.hasNext()) {
         X509CertificatePair var4;
         if ((var4 = (X509CertificatePair)var8.next()).getForward() != null) {
            var6.add(var4.getForward());
         }

         if (var4.getReverse() != null) {
            xselector1.add(var4.getReverse());
         }
      }

      var2.addAll(var6);
      var2.addAll(xselector1);
      return var2;
   }

   public void engineInit(X509StoreParameters params) {
      if (params instanceof X509LDAPCertStoreParameters) {
         this.helper = new LDAPStoreHelper((X509LDAPCertStoreParameters)params);
      } else {
         throw new IllegalArgumentException("Initialization parameters must be an instance of " + X509LDAPCertStoreParameters.class.getName() + ".");
      }
   }

   public Collection engineGetMatches(Selector selector) {
      if (!(selector instanceof X509CertStoreSelector)) {
         return Collections.EMPTY_SET;
      } else {
         X509CertStoreSelector selector1;
         X509CertStoreSelector var10000 = selector1 = (X509CertStoreSelector)selector;
         HashSet var2;
         var2 = new HashSet.<init>();
         if (var10000.getBasicConstraints() > 0) {
            var2.addAll(this.helper.getCACertificates(selector1));
            var2.addAll(this.getCertificatesFromCrossCertificatePairs(selector1));
         } else if (selector1.getBasicConstraints() == -2) {
            var2.addAll(this.helper.getUserCertificates(selector1));
         } else {
            var2.addAll(this.helper.getUserCertificates(selector1));
            var2.addAll(this.helper.getCACertificates(selector1));
            var2.addAll(this.getCertificatesFromCrossCertificatePairs(selector1));
         }

         return var2;
      }
   }
}
